<?php

namespace Easy\EasyArray;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsInsertVoucherResp EasyArray
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfClsInsertVoucherResp
 * @package Easy
 * @subpackage Arrays
 */
class EasyArrayOfClsInsertVoucherResp extends AbstractStructArrayBase
{
    /**
     * The ClsInsertVoucherResp
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Easy\EasyStruct\EasyClsInsertVoucherResp[]
     */
    public $ClsInsertVoucherResp;
    /**
     * Constructor method for ArrayOfClsInsertVoucherResp
     * @uses EasyArrayOfClsInsertVoucherResp::setClsInsertVoucherResp()
     * @param \Easy\EasyStruct\EasyClsInsertVoucherResp[] $clsInsertVoucherResp
     */
    public function __construct(array $clsInsertVoucherResp = array())
    {
        $this
            ->setClsInsertVoucherResp($clsInsertVoucherResp);
    }
    /**
     * Get ClsInsertVoucherResp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Easy\EasyStruct\EasyClsInsertVoucherResp[]|null
     */
    public function getClsInsertVoucherResp()
    {
        return isset($this->ClsInsertVoucherResp) ? $this->ClsInsertVoucherResp : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsInsertVoucherResp method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsInsertVoucherResp method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsInsertVoucherRespForArrayConstraintsFromSetClsInsertVoucherResp(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsInsertVoucherRespClsInsertVoucherRespItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsInsertVoucherRespClsInsertVoucherRespItem instanceof \Easy\EasyStruct\EasyClsInsertVoucherResp) {
                $invalidValues[] = is_object($arrayOfClsInsertVoucherRespClsInsertVoucherRespItem) ? get_class($arrayOfClsInsertVoucherRespClsInsertVoucherRespItem) : sprintf('%s(%s)', gettype($arrayOfClsInsertVoucherRespClsInsertVoucherRespItem), var_export($arrayOfClsInsertVoucherRespClsInsertVoucherRespItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ClsInsertVoucherResp property can only contain items of type \Easy\EasyStruct\EasyClsInsertVoucherResp, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ClsInsertVoucherResp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Easy\EasyStruct\EasyClsInsertVoucherResp[] $clsInsertVoucherResp
     * @return \Easy\EasyArray\EasyArrayOfClsInsertVoucherResp
     */
    public function setClsInsertVoucherResp(array $clsInsertVoucherResp = array())
    {
        // validation for constraint: array
        if ('' !== ($clsInsertVoucherRespArrayErrorMessage = self::validateClsInsertVoucherRespForArrayConstraintsFromSetClsInsertVoucherResp($clsInsertVoucherResp))) {
            throw new \InvalidArgumentException($clsInsertVoucherRespArrayErrorMessage, __LINE__);
        }
        if (is_null($clsInsertVoucherResp) || (is_array($clsInsertVoucherResp) && empty($clsInsertVoucherResp))) {
            unset($this->ClsInsertVoucherResp);
        } else {
            $this->ClsInsertVoucherResp = $clsInsertVoucherResp;
        }
        return $this;
    }
    /**
     * Add item to ClsInsertVoucherResp value
     * @throws \InvalidArgumentException
     * @param \Easy\EasyStruct\EasyClsInsertVoucherResp $item
     * @return \Easy\EasyArray\EasyArrayOfClsInsertVoucherResp
     */
    public function addToClsInsertVoucherResp(\Easy\EasyStruct\EasyClsInsertVoucherResp $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Easy\EasyStruct\EasyClsInsertVoucherResp) {
            throw new \InvalidArgumentException(sprintf('The ClsInsertVoucherResp property can only contain items of type \Easy\EasyStruct\EasyClsInsertVoucherResp, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ClsInsertVoucherResp[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Easy\EasyStruct\EasyClsInsertVoucherResp|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Easy\EasyStruct\EasyClsInsertVoucherResp|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Easy\EasyStruct\EasyClsInsertVoucherResp|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Easy\EasyStruct\EasyClsInsertVoucherResp|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Easy\EasyStruct\EasyClsInsertVoucherResp|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ClsInsertVoucherResp
     */
    public function getAttributeName()
    {
        return 'ClsInsertVoucherResp';
    }
}
