<?php

namespace Easy\EasyArray;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsVoucherCheckpoint EasyArray
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfClsVoucherCheckpoint
 * @package Easy
 * @subpackage Arrays
 */
class EasyArrayOfClsVoucherCheckpoint extends AbstractStructArrayBase
{
    /**
     * The ClsVoucherCheckpoint
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Easy\EasyStruct\EasyClsVoucherCheckpoint[]
     */
    public $ClsVoucherCheckpoint;
    /**
     * Constructor method for ArrayOfClsVoucherCheckpoint
     * @uses EasyArrayOfClsVoucherCheckpoint::setClsVoucherCheckpoint()
     * @param \Easy\EasyStruct\EasyClsVoucherCheckpoint[] $clsVoucherCheckpoint
     */
    public function __construct(array $clsVoucherCheckpoint = array())
    {
        $this
            ->setClsVoucherCheckpoint($clsVoucherCheckpoint);
    }
    /**
     * Get ClsVoucherCheckpoint value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Easy\EasyStruct\EasyClsVoucherCheckpoint[]|null
     */
    public function getClsVoucherCheckpoint()
    {
        return isset($this->ClsVoucherCheckpoint) ? $this->ClsVoucherCheckpoint : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsVoucherCheckpoint method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsVoucherCheckpoint method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsVoucherCheckpointForArrayConstraintsFromSetClsVoucherCheckpoint(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsVoucherCheckpointClsVoucherCheckpointItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsVoucherCheckpointClsVoucherCheckpointItem instanceof \Easy\EasyStruct\EasyClsVoucherCheckpoint) {
                $invalidValues[] = is_object($arrayOfClsVoucherCheckpointClsVoucherCheckpointItem) ? get_class($arrayOfClsVoucherCheckpointClsVoucherCheckpointItem) : sprintf('%s(%s)', gettype($arrayOfClsVoucherCheckpointClsVoucherCheckpointItem), var_export($arrayOfClsVoucherCheckpointClsVoucherCheckpointItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ClsVoucherCheckpoint property can only contain items of type \Easy\EasyStruct\EasyClsVoucherCheckpoint, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ClsVoucherCheckpoint value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Easy\EasyStruct\EasyClsVoucherCheckpoint[] $clsVoucherCheckpoint
     * @return \Easy\EasyArray\EasyArrayOfClsVoucherCheckpoint
     */
    public function setClsVoucherCheckpoint(array $clsVoucherCheckpoint = array())
    {
        // validation for constraint: array
        if ('' !== ($clsVoucherCheckpointArrayErrorMessage = self::validateClsVoucherCheckpointForArrayConstraintsFromSetClsVoucherCheckpoint($clsVoucherCheckpoint))) {
            throw new \InvalidArgumentException($clsVoucherCheckpointArrayErrorMessage, __LINE__);
        }
        if (is_null($clsVoucherCheckpoint) || (is_array($clsVoucherCheckpoint) && empty($clsVoucherCheckpoint))) {
            unset($this->ClsVoucherCheckpoint);
        } else {
            $this->ClsVoucherCheckpoint = $clsVoucherCheckpoint;
        }
        return $this;
    }
    /**
     * Add item to ClsVoucherCheckpoint value
     * @throws \InvalidArgumentException
     * @param \Easy\EasyStruct\EasyClsVoucherCheckpoint $item
     * @return \Easy\EasyArray\EasyArrayOfClsVoucherCheckpoint
     */
    public function addToClsVoucherCheckpoint(\Easy\EasyStruct\EasyClsVoucherCheckpoint $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Easy\EasyStruct\EasyClsVoucherCheckpoint) {
            throw new \InvalidArgumentException(sprintf('The ClsVoucherCheckpoint property can only contain items of type \Easy\EasyStruct\EasyClsVoucherCheckpoint, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ClsVoucherCheckpoint[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Easy\EasyStruct\EasyClsVoucherCheckpoint|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Easy\EasyStruct\EasyClsVoucherCheckpoint|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Easy\EasyStruct\EasyClsVoucherCheckpoint|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Easy\EasyStruct\EasyClsVoucherCheckpoint|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Easy\EasyStruct\EasyClsVoucherCheckpoint|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ClsVoucherCheckpoint
     */
    public function getAttributeName()
    {
        return 'ClsVoucherCheckpoint';
    }
}
