<?php

namespace Easy;

/**
 * Class which returns the class map definition
 * @package Easy
 */
class EasyClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetData' => '\\Easy\\EasyStruct\\EasyGetData',
            'GetDataResponse' => '\\Easy\\EasyStruct\\EasyGetDataResponse',
            'GetDataUsingDataContract' => '\\Easy\\EasyStruct\\EasyGetDataUsingDataContract',
            'GetDataUsingDataContractResponse' => '\\Easy\\EasyStruct\\EasyGetDataUsingDataContractResponse',
            'InsertVoucher' => '\\Easy\\EasyStruct\\EasyInsertVoucher',
            'InsertVoucherResponse' => '\\Easy\\EasyStruct\\EasyInsertVoucherResponse',
            'Upload_XL_File' => '\\Easy\\EasyStruct\\EasyUpload_XL_File',
            'Upload_XL_FileResponse' => '\\Easy\\EasyStruct\\EasyUpload_XL_FileResponse',
            'GetShipmentNumber' => '\\Easy\\EasyStruct\\EasyGetShipmentNumber',
            'GetShipmentNumberResponse' => '\\Easy\\EasyStruct\\EasyGetShipmentNumberResponse',
            'GetVoucher' => '\\Easy\\EasyStruct\\EasyGetVoucher',
            'GetVoucherResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherResponse',
            'GetVoucherMargins' => '\\Easy\\EasyStruct\\EasyGetVoucherMargins',
            'GetVoucherMarginsResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherMarginsResponse',
            'GetVoucherPdf_Background' => '\\Easy\\EasyStruct\\EasyGetVoucherPdf_Background',
            'GetVoucherPdf_BackgroundResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherPdf_BackgroundResponse',
            'GetVoucherTracking' => '\\Easy\\EasyStruct\\EasyGetVoucherTracking',
            'GetVoucherTrackingResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherTrackingResponse',
            'GetVoucherTrackingLanguage' => '\\Easy\\EasyStruct\\EasyGetVoucherTrackingLanguage',
            'GetVoucherTrackingLanguageResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherTrackingLanguageResponse',
            'GetVoucherTracking_Station' => '\\Easy\\EasyStruct\\EasyGetVoucherTracking_Station',
            'GetVoucherTracking_StationResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherTracking_StationResponse',
            'GetVouchersTracking_By_TimePeriod' => '\\Easy\\EasyStruct\\EasyGetVouchersTracking_By_TimePeriod',
            'GetVouchersTracking_By_TimePeriodResponse' => '\\Easy\\EasyStruct\\EasyGetVouchersTracking_By_TimePeriodResponse',
            'GetVouchersTracking_By_TimePeriod2' => '\\Easy\\EasyStruct\\EasyGetVouchersTracking_By_TimePeriod2',
            'GetVouchersTracking_By_TimePeriod2Response' => '\\Easy\\EasyStruct\\EasyGetVouchersTracking_By_TimePeriod2Response',
            'GetVouchersTracking_By_ItemID' => '\\Easy\\EasyStruct\\EasyGetVouchersTracking_By_ItemID',
            'GetVouchersTracking_By_ItemIDResponse' => '\\Easy\\EasyStruct\\EasyGetVouchersTracking_By_ItemIDResponse',
            'GetVoucherTracking_By_ItemID' => '\\Easy\\EasyStruct\\EasyGetVoucherTracking_By_ItemID',
            'GetVoucherTracking_By_ItemIDResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherTracking_By_ItemIDResponse',
            'CheckSpecials' => '\\Easy\\EasyStruct\\EasyCheckSpecials',
            'CheckSpecialsResponse' => '\\Easy\\EasyStruct\\EasyCheckSpecialsResponse',
            'CancelVoucher' => '\\Easy\\EasyStruct\\EasyCancelVoucher',
            'CancelVoucherResponse' => '\\Easy\\EasyStruct\\EasyCancelVoucherResponse',
            'GetVouchersXps' => '\\Easy\\EasyStruct\\EasyGetVouchersXps',
            'GetVouchersXpsResponse' => '\\Easy\\EasyStruct\\EasyGetVouchersXpsResponse',
            'GetVouchersXps_Url' => '\\Easy\\EasyStruct\\EasyGetVouchersXps_Url',
            'GetVouchersXps_UrlResponse' => '\\Easy\\EasyStruct\\EasyGetVouchersXps_UrlResponse',
            'GetVouchersPdf' => '\\Easy\\EasyStruct\\EasyGetVouchersPdf',
            'GetVouchersPdfResponse' => '\\Easy\\EasyStruct\\EasyGetVouchersPdfResponse',
            'GetVouchersPdf_Url' => '\\Easy\\EasyStruct\\EasyGetVouchersPdf_Url',
            'GetVouchersPdf_UrlResponse' => '\\Easy\\EasyStruct\\EasyGetVouchersPdf_UrlResponse',
            'GetVouchers_Str_Pdf_Url' => '\\Easy\\EasyStruct\\EasyGetVouchers_Str_Pdf_Url',
            'GetVouchers_Str_Pdf_UrlResponse' => '\\Easy\\EasyStruct\\EasyGetVouchers_Str_Pdf_UrlResponse',
            'GetVouchersPdf2A4' => '\\Easy\\EasyStruct\\EasyGetVouchersPdf2A4',
            'GetVouchersPdf2A4Response' => '\\Easy\\EasyStruct\\EasyGetVouchersPdf2A4Response',
            'GetVoucherPOD' => '\\Easy\\EasyStruct\\EasyGetVoucherPOD',
            'GetVoucherPODResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherPODResponse',
            'GetVouchersPdf3A4' => '\\Easy\\EasyStruct\\EasyGetVouchersPdf3A4',
            'GetVouchersPdf3A4Response' => '\\Easy\\EasyStruct\\EasyGetVouchersPdf3A4Response',
            'InsertCustomerCostCenter' => '\\Easy\\EasyStruct\\EasyInsertCustomerCostCenter',
            'InsertCustomerCostCenterResponse' => '\\Easy\\EasyStruct\\EasyInsertCustomerCostCenterResponse',
            'UpdateCustomerCostCenter' => '\\Easy\\EasyStruct\\EasyUpdateCustomerCostCenter',
            'UpdateCustomerCostCenterResponse' => '\\Easy\\EasyStruct\\EasyUpdateCustomerCostCenterResponse',
            'GetCustomer' => '\\Easy\\EasyStruct\\EasyGetCustomer',
            'GetCustomerResponse' => '\\Easy\\EasyStruct\\EasyGetCustomerResponse',
            'GetVoucherPDFA6Margins' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFA6Margins',
            'GetVoucherPDFA6MarginsResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFA6MarginsResponse',
            'GetVoucherPDFMargins' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFMargins',
            'GetVoucherPDFMarginsResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFMarginsResponse',
            'GetVoucherPDFA4Double' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFA4Double',
            'GetVoucherPDFA4DoubleResponse' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFA4DoubleResponse',
            'GetVoucherPDFA4' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFA4',
            'GetVoucherPDFA4Response' => '\\Easy\\EasyStruct\\EasyGetVoucherPDFA4Response',
            'InsertPickUpOrder' => '\\Easy\\EasyStruct\\EasyInsertPickUpOrder',
            'InsertPickUpOrderResponse' => '\\Easy\\EasyStruct\\EasyInsertPickUpOrderResponse',
            'TrackPickUpOrderByPickUpOrderID' => '\\Easy\\EasyStruct\\EasyTrackPickUpOrderByPickUpOrderID',
            'TrackPickUpOrderByPickUpOrderIDResponse' => '\\Easy\\EasyStruct\\EasyTrackPickUpOrderByPickUpOrderIDResponse',
            'TrackPickUpOrderByItemID' => '\\Easy\\EasyStruct\\EasyTrackPickUpOrderByItemID',
            'TrackPickUpOrderByItemIDResponse' => '\\Easy\\EasyStruct\\EasyTrackPickUpOrderByItemIDResponse',
            'TrackPickUpOrderByShipmentNumber' => '\\Easy\\EasyStruct\\EasyTrackPickUpOrderByShipmentNumber',
            'TrackPickUpOrderByShipmentNumberResponse' => '\\Easy\\EasyStruct\\EasyTrackPickUpOrderByShipmentNumberResponse',
            'CancelPickUpOrder' => '\\Easy\\EasyStruct\\EasyCancelPickUpOrder',
            'CancelPickUpOrderResponse' => '\\Easy\\EasyStruct\\EasyCancelPickUpOrderResponse',
            'CompositeType' => '\\Easy\\EasyStruct\\EasyCompositeType',
            'ClsVoucher' => '\\Easy\\EasyStruct\\EasyClsVoucher',
            'ClsCredential' => '\\Easy\\EasyStruct\\EasyClsCredential',
            'ClsInsertVoucherResp' => '\\Easy\\EasyStruct\\EasyClsInsertVoucherResp',
            'ArrayOfClsInsertVoucherResp' => '\\Easy\\EasyArray\\EasyArrayOfClsInsertVoucherResp',
            'ClsGetShipmentNumberResp' => '\\Easy\\EasyStruct\\EasyClsGetShipmentNumberResp',
            'ClsGetVoucherResp' => '\\Easy\\EasyStruct\\EasyClsGetVoucherResp',
            'ClsVoucherTracking' => '\\Easy\\EasyStruct\\EasyClsVoucherTracking',
            'ArrayOfClsVoucherCheckpoint' => '\\Easy\\EasyArray\\EasyArrayOfClsVoucherCheckpoint',
            'ClsVoucherCheckpoint' => '\\Easy\\EasyStruct\\EasyClsVoucherCheckpoint',
            'ClsGetVoucherPDFResp' => '\\Easy\\EasyStruct\\EasyClsGetVoucherPDFResp',
            'ClsGetVoucherTrackingResp' => '\\Easy\\EasyStruct\\EasyClsGetVoucherTrackingResp',
            'ClsGetVoucherTracking_StationResp' => '\\Easy\\EasyStruct\\EasyClsGetVoucherTracking_StationResp',
            'ClsVoucherTracking_Station' => '\\Easy\\EasyStruct\\EasyClsVoucherTracking_Station',
            'ArrayOfClsVoucherCheckpoint_Station' => '\\Easy\\EasyArray\\EasyArrayOfClsVoucherCheckpoint_Station',
            'ClsVoucherCheckpoint_Station' => '\\Easy\\EasyStruct\\EasyClsVoucherCheckpoint_Station',
            'ClsStation' => '\\Easy\\EasyStruct\\EasyClsStation',
            'ClsVouchersTrackingTimePeriodResp' => '\\Easy\\EasyStruct\\EasyClsVouchersTrackingTimePeriodResp',
            'ArrayOfClsGetVoucherTracking_StationResp' => '\\Easy\\EasyArray\\EasyArrayOfClsGetVoucherTracking_StationResp',
            'ClsVouchersTrackingTimePeriodResp2' => '\\Easy\\EasyStruct\\EasyClsVouchersTrackingTimePeriodResp2',
            'ArrayOfClsGetVoucherTracking_StationResp2' => '\\Easy\\EasyArray\\EasyArrayOfClsGetVoucherTracking_StationResp2',
            'ClsGetVoucherTracking_StationResp2' => '\\Easy\\EasyStruct\\EasyClsGetVoucherTracking_StationResp2',
            'ClsVoucherTracking_Station2' => '\\Easy\\EasyStruct\\EasyClsVoucherTracking_Station2',
            'ArrayOfClsVoucherCheckpoint_Station2' => '\\Easy\\EasyArray\\EasyArrayOfClsVoucherCheckpoint_Station2',
            'ClsVoucherCheckpoint_Station2' => '\\Easy\\EasyStruct\\EasyClsVoucherCheckpoint_Station2',
            'ClsVouchersTracking_By_ItemIDResp' => '\\Easy\\EasyStruct\\EasyClsVouchersTracking_By_ItemIDResp',
            'ClsCheckSpecialsResp' => '\\Easy\\EasyStruct\\EasyClsCheckSpecialsResp',
            'ClsCancelVoucherResp' => '\\Easy\\EasyStruct\\EasyClsCancelVoucherResp',
            'ClsGetVouchersXpsResp' => '\\Easy\\EasyStruct\\EasyClsGetVouchersXpsResp',
            'ClsGetVouchersXps_UrlResp' => '\\Easy\\EasyStruct\\EasyClsGetVouchersXps_UrlResp',
            'ClsGetVouchersPdfResp' => '\\Easy\\EasyStruct\\EasyClsGetVouchersPdfResp',
            'ClsGetVouchersPdf_UrlResp' => '\\Easy\\EasyStruct\\EasyClsGetVouchersPdf_UrlResp',
            'ClsGetVoucherPODResp' => '\\Easy\\EasyStruct\\EasyClsGetVoucherPODResp',
            'ClsCustomerCostCenter' => '\\Easy\\EasyStruct\\EasyClsCustomerCostCenter',
            'ClsInsertCustomerCostCenterResp' => '\\Easy\\EasyStruct\\EasyClsInsertCustomerCostCenterResp',
            'ClsUpdateCustomerCostCenterResp' => '\\Easy\\EasyStruct\\EasyClsUpdateCustomerCostCenterResp',
            'ClsGetCustomerResp' => '\\Easy\\EasyStruct\\EasyClsGetCustomerResp',
            'ClsPickUpOrder' => '\\Easy\\EasyStruct\\EasyClsPickUpOrder',
            'ClsInsertPickUpOrderResp' => '\\Easy\\EasyStruct\\EasyClsInsertPickUpOrderResp',
            'ClsTrackPickUpOrderResp' => '\\Easy\\EasyStruct\\EasyClsTrackPickUpOrderResp',
            'ClsCancelPickUpOrderResp' => '\\Easy\\EasyStruct\\EasyClsCancelPickUpOrderResp',
            'ArrayOfstring' => '\\Easy\\EasyArray\\EasyArrayOfstring',
            'ArrayOfdecimal' => '\\Easy\\EasyArray\\EasyArrayOfdecimal',
        );
    }
}
