<?php

namespace Easy\EasyStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ClsInsertCustomerCostCenterResp EasyStruct
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ClsInsertCustomerCostCenterResp
 * @package Easy
 * @subpackage Structs
 */
class EasyClsInsertCustomerCostCenterResp extends AbstractStructBase
{
    /**
     * The CustomerID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $CustomerID;
    /**
     * The Messages
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Easy\EasyArray\EasyArrayOfstring
     */
    public $Messages;
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Result;
    /**
     * Constructor method for ClsInsertCustomerCostCenterResp
     * @uses EasyClsInsertCustomerCostCenterResp::setCustomerID()
     * @uses EasyClsInsertCustomerCostCenterResp::setMessages()
     * @uses EasyClsInsertCustomerCostCenterResp::setResult()
     * @param int $customerID
     * @param \Easy\EasyArray\EasyArrayOfstring $messages
     * @param bool $result
     */
    public function __construct($customerID = null, \Easy\EasyArray\EasyArrayOfstring $messages = null, $result = null)
    {
        $this
            ->setCustomerID($customerID)
            ->setMessages($messages)
            ->setResult($result);
    }
    /**
     * Get CustomerID value
     * @return int|null
     */
    public function getCustomerID()
    {
        return $this->CustomerID;
    }
    /**
     * Set CustomerID value
     * @param int $customerID
     * @return \Easy\EasyStruct\EasyClsInsertCustomerCostCenterResp
     */
    public function setCustomerID($customerID = null)
    {
        // validation for constraint: int
        if (!is_null($customerID) && !(is_int($customerID) || ctype_digit($customerID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($customerID, true), gettype($customerID)), __LINE__);
        }
        $this->CustomerID = $customerID;
        return $this;
    }
    /**
     * Get Messages value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Easy\EasyArray\EasyArrayOfstring|null
     */
    public function getMessages()
    {
        return isset($this->Messages) ? $this->Messages : null;
    }
    /**
     * Set Messages value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Easy\EasyArray\EasyArrayOfstring $messages
     * @return \Easy\EasyStruct\EasyClsInsertCustomerCostCenterResp
     */
    public function setMessages(\Easy\EasyArray\EasyArrayOfstring $messages = null)
    {
        if (is_null($messages) || (is_array($messages) && empty($messages))) {
            unset($this->Messages);
        } else {
            $this->Messages = $messages;
        }
        return $this;
    }
    /**
     * Get Result value
     * @return bool|null
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param bool $result
     * @return \Easy\EasyStruct\EasyClsInsertCustomerCostCenterResp
     */
    public function setResult($result = null)
    {
        // validation for constraint: boolean
        if (!is_null($result) && !is_bool($result)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($result, true), gettype($result)), __LINE__);
        }
        $this->Result = $result;
        return $this;
    }
}
