<?php

namespace Easy\EasyStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ClsInsertPickUpOrderResp EasyStruct
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ClsInsertPickUpOrderResp
 * @package Easy
 * @subpackage Structs
 */
class EasyClsInsertPickUpOrderResp extends AbstractStructBase
{
    /**
     * The Messages
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Easy\EasyArray\EasyArrayOfstring
     */
    public $Messages;
    /**
     * The PickUpOrderID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PickUpOrderID;
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Result;
    /**
     * Constructor method for ClsInsertPickUpOrderResp
     * @uses EasyClsInsertPickUpOrderResp::setMessages()
     * @uses EasyClsInsertPickUpOrderResp::setPickUpOrderID()
     * @uses EasyClsInsertPickUpOrderResp::setResult()
     * @param \Easy\EasyArray\EasyArrayOfstring $messages
     * @param int $pickUpOrderID
     * @param bool $result
     */
    public function __construct(\Easy\EasyArray\EasyArrayOfstring $messages = null, $pickUpOrderID = null, $result = null)
    {
        $this
            ->setMessages($messages)
            ->setPickUpOrderID($pickUpOrderID)
            ->setResult($result);
    }
    /**
     * Get Messages value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Easy\EasyArray\EasyArrayOfstring|null
     */
    public function getMessages()
    {
        return isset($this->Messages) ? $this->Messages : null;
    }
    /**
     * Set Messages value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Easy\EasyArray\EasyArrayOfstring $messages
     * @return \Easy\EasyStruct\EasyClsInsertPickUpOrderResp
     */
    public function setMessages(\Easy\EasyArray\EasyArrayOfstring $messages = null)
    {
        if (is_null($messages) || (is_array($messages) && empty($messages))) {
            unset($this->Messages);
        } else {
            $this->Messages = $messages;
        }
        return $this;
    }
    /**
     * Get PickUpOrderID value
     * @return int|null
     */
    public function getPickUpOrderID()
    {
        return $this->PickUpOrderID;
    }
    /**
     * Set PickUpOrderID value
     * @param int $pickUpOrderID
     * @return \Easy\EasyStruct\EasyClsInsertPickUpOrderResp
     */
    public function setPickUpOrderID($pickUpOrderID = null)
    {
        // validation for constraint: int
        if (!is_null($pickUpOrderID) && !(is_int($pickUpOrderID) || ctype_digit($pickUpOrderID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pickUpOrderID, true), gettype($pickUpOrderID)), __LINE__);
        }
        $this->PickUpOrderID = $pickUpOrderID;
        return $this;
    }
    /**
     * Get Result value
     * @return bool|null
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param bool $result
     * @return \Easy\EasyStruct\EasyClsInsertPickUpOrderResp
     */
    public function setResult($result = null)
    {
        // validation for constraint: boolean
        if (!is_null($result) && !is_bool($result)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($result, true), gettype($result)), __LINE__);
        }
        $this->Result = $result;
        return $this;
    }
}
