<?php

namespace Easy\EasyStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVouchersPdf2A4 EasyStruct
 * @package Easy
 * @subpackage Structs
 */
class EasyGetVouchersPdf2A4 extends AbstractStructBase
{
    /**
     * The ShipmentNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $ShipmentNumber;
    /**
     * The Margin_Left
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Margin_Left;
    /**
     * The Margin_Top
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Margin_Top;
    /**
     * The Credential
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Easy\EasyStruct\EasyClsCredential
     */
    public $Credential;
    /**
     * Constructor method for GetVouchersPdf2A4
     * @uses EasyGetVouchersPdf2A4::setShipmentNumber()
     * @uses EasyGetVouchersPdf2A4::setMargin_Left()
     * @uses EasyGetVouchersPdf2A4::setMargin_Top()
     * @uses EasyGetVouchersPdf2A4::setCredential()
     * @param float $shipmentNumber
     * @param int $margin_Left
     * @param int $margin_Top
     * @param \Easy\EasyStruct\EasyClsCredential $credential
     */
    public function __construct($shipmentNumber = null, $margin_Left = null, $margin_Top = null, \Easy\EasyStruct\EasyClsCredential $credential = null)
    {
        $this
            ->setShipmentNumber($shipmentNumber)
            ->setMargin_Left($margin_Left)
            ->setMargin_Top($margin_Top)
            ->setCredential($credential);
    }
    /**
     * Get ShipmentNumber value
     * @return float|null
     */
    public function getShipmentNumber()
    {
        return $this->ShipmentNumber;
    }
    /**
     * Set ShipmentNumber value
     * @param float $shipmentNumber
     * @return \Easy\EasyStruct\EasyGetVouchersPdf2A4
     */
    public function setShipmentNumber($shipmentNumber = null)
    {
        // validation for constraint: float
        if (!is_null($shipmentNumber) && !(is_float($shipmentNumber) || is_numeric($shipmentNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($shipmentNumber, true), gettype($shipmentNumber)), __LINE__);
        }
        $this->ShipmentNumber = $shipmentNumber;
        return $this;
    }
    /**
     * Get Margin_Left value
     * @return int|null
     */
    public function getMargin_Left()
    {
        return $this->Margin_Left;
    }
    /**
     * Set Margin_Left value
     * @param int $margin_Left
     * @return \Easy\EasyStruct\EasyGetVouchersPdf2A4
     */
    public function setMargin_Left($margin_Left = null)
    {
        // validation for constraint: int
        if (!is_null($margin_Left) && !(is_int($margin_Left) || ctype_digit($margin_Left))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($margin_Left, true), gettype($margin_Left)), __LINE__);
        }
        $this->Margin_Left = $margin_Left;
        return $this;
    }
    /**
     * Get Margin_Top value
     * @return int|null
     */
    public function getMargin_Top()
    {
        return $this->Margin_Top;
    }
    /**
     * Set Margin_Top value
     * @param int $margin_Top
     * @return \Easy\EasyStruct\EasyGetVouchersPdf2A4
     */
    public function setMargin_Top($margin_Top = null)
    {
        // validation for constraint: int
        if (!is_null($margin_Top) && !(is_int($margin_Top) || ctype_digit($margin_Top))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($margin_Top, true), gettype($margin_Top)), __LINE__);
        }
        $this->Margin_Top = $margin_Top;
        return $this;
    }
    /**
     * Get Credential value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Easy\EasyStruct\EasyClsCredential|null
     */
    public function getCredential()
    {
        return isset($this->Credential) ? $this->Credential : null;
    }
    /**
     * Set Credential value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Easy\EasyStruct\EasyClsCredential $credential
     * @return \Easy\EasyStruct\EasyGetVouchersPdf2A4
     */
    public function setCredential(\Easy\EasyStruct\EasyClsCredential $credential = null)
    {
        if (is_null($credential) || (is_array($credential) && empty($credential))) {
            unset($this->Credential);
        } else {
            $this->Credential = $credential;
        }
        return $this;
    }
}
