<?php

namespace Easy\EasyStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateCustomerCostCenter EasyStruct
 * @package Easy
 * @subpackage Structs
 */
class EasyUpdateCustomerCostCenter extends AbstractStructBase
{
    /**
     * The CustomerCostCenter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Easy\EasyStruct\EasyClsCustomerCostCenter
     */
    public $CustomerCostCenter;
    /**
     * The ClsCredential
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Easy\EasyStruct\EasyClsCredential
     */
    public $ClsCredential;
    /**
     * Constructor method for UpdateCustomerCostCenter
     * @uses EasyUpdateCustomerCostCenter::setCustomerCostCenter()
     * @uses EasyUpdateCustomerCostCenter::setClsCredential()
     * @param \Easy\EasyStruct\EasyClsCustomerCostCenter $customerCostCenter
     * @param \Easy\EasyStruct\EasyClsCredential $clsCredential
     */
    public function __construct(\Easy\EasyStruct\EasyClsCustomerCostCenter $customerCostCenter = null, \Easy\EasyStruct\EasyClsCredential $clsCredential = null)
    {
        $this
            ->setCustomerCostCenter($customerCostCenter)
            ->setClsCredential($clsCredential);
    }
    /**
     * Get CustomerCostCenter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Easy\EasyStruct\EasyClsCustomerCostCenter|null
     */
    public function getCustomerCostCenter()
    {
        return isset($this->CustomerCostCenter) ? $this->CustomerCostCenter : null;
    }
    /**
     * Set CustomerCostCenter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Easy\EasyStruct\EasyClsCustomerCostCenter $customerCostCenter
     * @return \Easy\EasyStruct\EasyUpdateCustomerCostCenter
     */
    public function setCustomerCostCenter(\Easy\EasyStruct\EasyClsCustomerCostCenter $customerCostCenter = null)
    {
        if (is_null($customerCostCenter) || (is_array($customerCostCenter) && empty($customerCostCenter))) {
            unset($this->CustomerCostCenter);
        } else {
            $this->CustomerCostCenter = $customerCostCenter;
        }
        return $this;
    }
    /**
     * Get ClsCredential value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Easy\EasyStruct\EasyClsCredential|null
     */
    public function getClsCredential()
    {
        return isset($this->ClsCredential) ? $this->ClsCredential : null;
    }
    /**
     * Set ClsCredential value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Easy\EasyStruct\EasyClsCredential $clsCredential
     * @return \Easy\EasyStruct\EasyUpdateCustomerCostCenter
     */
    public function setClsCredential(\Easy\EasyStruct\EasyClsCredential $clsCredential = null)
    {
        if (is_null($clsCredential) || (is_array($clsCredential) && empty($clsCredential))) {
            unset($this->ClsCredential);
        } else {
            $this->ClsCredential = $clsCredential;
        }
        return $this;
    }
}
