<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the first needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientBase class (each generated ServiceType class extends this class)
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://webservices.easy-mail.gr/WcfShippingSSL/Shipping.svc?singleWsdl',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc...
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://webservices.easy-mail.gr/WcfShippingSSL/Shipping.svc?singleWsdl',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => \Easy\EasyClassMap::get(),
);
/**
 * Samples for Get ServiceType
 */
$get = new \Easy\EasyService\EasyGet($options);
/**
 * Sample call for GetData operation/method
 */
if ($get->GetData(new \Easy\EasyStruct\EasyGetData()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetDataUsingDataContract operation/method
 */
if ($get->GetDataUsingDataContract(new \Easy\EasyStruct\EasyGetDataUsingDataContract()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetShipmentNumber operation/method
 */
if ($get->GetShipmentNumber(new \Easy\EasyStruct\EasyGetShipmentNumber()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucher operation/method
 */
if ($get->GetVoucher(new \Easy\EasyStruct\EasyGetVoucher()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherMargins operation/method
 */
if ($get->GetVoucherMargins(new \Easy\EasyStruct\EasyGetVoucherMargins()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPdf_Background operation/method
 */
if ($get->GetVoucherPdf_Background(new \Easy\EasyStruct\EasyGetVoucherPdf_Background()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherTracking operation/method
 */
if ($get->GetVoucherTracking(new \Easy\EasyStruct\EasyGetVoucherTracking()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherTrackingLanguage operation/method
 */
if ($get->GetVoucherTrackingLanguage(new \Easy\EasyStruct\EasyGetVoucherTrackingLanguage()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherTracking_Station operation/method
 */
if ($get->GetVoucherTracking_Station(new \Easy\EasyStruct\EasyGetVoucherTracking_Station()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersTracking_By_TimePeriod operation/method
 */
if ($get->GetVouchersTracking_By_TimePeriod(new \Easy\EasyStruct\EasyGetVouchersTracking_By_TimePeriod()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersTracking_By_TimePeriod2 operation/method
 */
if ($get->GetVouchersTracking_By_TimePeriod2(new \Easy\EasyStruct\EasyGetVouchersTracking_By_TimePeriod2()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersTracking_By_ItemID operation/method
 */
if ($get->GetVouchersTracking_By_ItemID(new \Easy\EasyStruct\EasyGetVouchersTracking_By_ItemID()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherTracking_By_ItemID operation/method
 */
if ($get->GetVoucherTracking_By_ItemID(new \Easy\EasyStruct\EasyGetVoucherTracking_By_ItemID()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersXps operation/method
 */
if ($get->GetVouchersXps(new \Easy\EasyStruct\EasyGetVouchersXps()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersXps_Url operation/method
 */
if ($get->GetVouchersXps_Url(new \Easy\EasyStruct\EasyGetVouchersXps_Url()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersPdf operation/method
 */
if ($get->GetVouchersPdf(new \Easy\EasyStruct\EasyGetVouchersPdf()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersPdf_Url operation/method
 */
if ($get->GetVouchersPdf_Url(new \Easy\EasyStruct\EasyGetVouchersPdf_Url()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchers_Str_Pdf_Url operation/method
 */
if ($get->GetVouchers_Str_Pdf_Url(new \Easy\EasyStruct\EasyGetVouchers_Str_Pdf_Url()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersPdf2A4 operation/method
 */
if ($get->GetVouchersPdf2A4(new \Easy\EasyStruct\EasyGetVouchersPdf2A4()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPOD operation/method
 */
if ($get->GetVoucherPOD(new \Easy\EasyStruct\EasyGetVoucherPOD()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVouchersPdf3A4 operation/method
 */
if ($get->GetVouchersPdf3A4(new \Easy\EasyStruct\EasyGetVouchersPdf3A4()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetCustomer operation/method
 */
if ($get->GetCustomer(new \Easy\EasyStruct\EasyGetCustomer()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPDFA6Margins operation/method
 */
if ($get->GetVoucherPDFA6Margins(new \Easy\EasyStruct\EasyGetVoucherPDFA6Margins()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPDFMargins operation/method
 */
if ($get->GetVoucherPDFMargins(new \Easy\EasyStruct\EasyGetVoucherPDFMargins()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPDFA4Double operation/method
 */
if ($get->GetVoucherPDFA4Double(new \Easy\EasyStruct\EasyGetVoucherPDFA4Double()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetVoucherPDFA4 operation/method
 */
if ($get->GetVoucherPDFA4(new \Easy\EasyStruct\EasyGetVoucherPDFA4()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Samples for Insert ServiceType
 */
$insert = new \Easy\EasyService\EasyInsert($options);
/**
 * Sample call for InsertVoucher operation/method
 */
if ($insert->InsertVoucher(new \Easy\EasyStruct\EasyInsertVoucher()) !== false) {
    print_r($insert->getResult());
} else {
    print_r($insert->getLastError());
}
/**
 * Sample call for InsertCustomerCostCenter operation/method
 */
if ($insert->InsertCustomerCostCenter(new \Easy\EasyStruct\EasyInsertCustomerCostCenter()) !== false) {
    print_r($insert->getResult());
} else {
    print_r($insert->getLastError());
}
/**
 * Sample call for InsertPickUpOrder operation/method
 */
if ($insert->InsertPickUpOrder(new \Easy\EasyStruct\EasyInsertPickUpOrder()) !== false) {
    print_r($insert->getResult());
} else {
    print_r($insert->getLastError());
}
/**
 * Samples for Upload ServiceType
 */
$upload = new \Easy\EasyService\EasyUpload($options);
/**
 * Sample call for Upload_XL_File operation/method
 */
if ($upload->Upload_XL_File(new \Easy\EasyStruct\EasyUpload_XL_File()) !== false) {
    print_r($upload->getResult());
} else {
    print_r($upload->getLastError());
}
/**
 * Samples for Check ServiceType
 */
$check = new \Easy\EasyService\EasyCheck($options);
/**
 * Sample call for CheckSpecials operation/method
 */
if ($check->CheckSpecials(new \Easy\EasyStruct\EasyCheckSpecials()) !== false) {
    print_r($check->getResult());
} else {
    print_r($check->getLastError());
}
/**
 * Samples for Cancel ServiceType
 */
$cancel = new \Easy\EasyService\EasyCancel($options);
/**
 * Sample call for CancelVoucher operation/method
 */
if ($cancel->CancelVoucher(new \Easy\EasyStruct\EasyCancelVoucher()) !== false) {
    print_r($cancel->getResult());
} else {
    print_r($cancel->getLastError());
}
/**
 * Sample call for CancelPickUpOrder operation/method
 */
if ($cancel->CancelPickUpOrder(new \Easy\EasyStruct\EasyCancelPickUpOrder()) !== false) {
    print_r($cancel->getResult());
} else {
    print_r($cancel->getLastError());
}
/**
 * Samples for Update ServiceType
 */
$update = new \Easy\EasyService\EasyUpdate($options);
/**
 * Sample call for UpdateCustomerCostCenter operation/method
 */
if ($update->UpdateCustomerCostCenter(new \Easy\EasyStruct\EasyUpdateCustomerCostCenter()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Samples for Track ServiceType
 */
$track = new \Easy\EasyService\EasyTrack($options);
/**
 * Sample call for TrackPickUpOrderByPickUpOrderID operation/method
 */
if ($track->TrackPickUpOrderByPickUpOrderID(new \Easy\EasyStruct\EasyTrackPickUpOrderByPickUpOrderID()) !== false) {
    print_r($track->getResult());
} else {
    print_r($track->getLastError());
}
/**
 * Sample call for TrackPickUpOrderByItemID operation/method
 */
if ($track->TrackPickUpOrderByItemID(new \Easy\EasyStruct\EasyTrackPickUpOrderByItemID()) !== false) {
    print_r($track->getResult());
} else {
    print_r($track->getLastError());
}
/**
 * Sample call for TrackPickUpOrderByShipmentNumber operation/method
 */
if ($track->TrackPickUpOrderByShipmentNumber(new \Easy\EasyStruct\EasyTrackPickUpOrderByShipmentNumber()) !== false) {
    print_r($track->getResult());
} else {
    print_r($track->getLastError());
}
